'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pick = undefined;
exports.formChangeObject = formChangeObject;
exports.codeComplete = codeComplete;

var _messaging = require('../../../kernel/messaging');

// Hint picker
const pick = exports.pick = (cm, handle) => handle.pick();

function formChangeObject(cm, change) {
  return {
    cm,
    change
  };
}

function codeComplete(channels, editor) {
  const cursor = editor.getCursor();
  const cursorPos = editor.indexFromPos(cursor);
  const code = editor.getValue();

  const message = (0, _messaging.createMessage)('complete_request');
  message.content = {
    code,
    cursor_pos: cursorPos
  };

  return {
    observable: channels.shell.childOf(message).ofMessageType('complete_reply').pluck('content').first().map(results => ({
      list: results.matches,
      from: editor.posFromIndex(results.cursor_start),
      to: editor.posFromIndex(results.cursor_end)
    })).timeout(2000), // 4s
    message
  };
}