'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _transformimeReact = require('transformime-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Pager extends _react2.default.Component {

  shouldComponentUpdate() {
    // eslint-disable-line class-methods-use-this
    // It's always brand new
    return false;
  }

  render() {
    const bundle = this.props.data;
    const mimetype = (0, _transformimeReact.richestMimetype)(bundle, this.props.displayOrder, this.props.transforms);
    if (!mimetype) {
      return null;
    }

    const Transform = this.props.transforms.get(mimetype);
    return _react2.default.createElement(Transform, { data: bundle.get(mimetype) });
  }
}

Pager.propTypes = {
  displayOrder: _react2.default.PropTypes.instanceOf(_immutable2.default.List).isRequired,
  transforms: _react2.default.PropTypes.instanceOf(_immutable2.default.Map).isRequired,
  data: _react2.default.PropTypes.instanceOf(_immutable2.default.Map).isRequired
};
exports.default = Pager;