'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultTransforms = exports.defaultDisplayOrder = undefined;

var _transformimeReact = require('transformime-react');

var _plotly = require('./plotly');

var _plotly2 = _interopRequireDefault(_plotly);

var _geojson = require('./geojson');

var _geojson2 = _interopRequireDefault(_geojson);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Register custom transforms


/**
 * Thus begins our path for custom mimetypes and future extensions
 */

const defaultTransforms = _transformimeReact.transforms.set(_plotly2.default.MIMETYPE, _plotly2.default).set(_geojson2.default.MIMETYPE, _geojson2.default);

// Register our custom transforms as the most rich (front of List)
const defaultDisplayOrder = _transformimeReact.displayOrder.insert(0, _plotly2.default.MIMETYPE).insert(0, _geojson2.default.MIMETYPE);

exports.defaultDisplayOrder = defaultDisplayOrder;
exports.defaultTransforms = defaultTransforms;